/* SPARC Processor specifics
 * taken from the SPARC port of Linux (ptrace.h).
 *
 * Daniel Hellstrm (hedani3l.no.bots.here.yahoo.com)
 * Copyright (C) 2007
 */

#ifndef __ASM_SPARC_PROCESSOR_H
#define __ASM_SPARC_PROCESSOR_H


#ifdef CONFIG_LEON3
#include <asm/leon3.h>

/* Macros for bypassing cache when reading */
#define SPARC_BYPASS_READ_QWORD(address) leon_load_reg_cachemiss_qword((unsigned int)(address))
#define SPARC_BYPASS_READ(address) leon_load_reg_cachemiss((unsigned int)(address))
#define SPARC_BYPASS_READ_WORD(address) leon_load_reg_cachemiss_word((unsigned int)(address))
#define SPARC_BYPASS_READ_BYTE(address) leon_load_reg_cachemiss_byte((unsigned int)(address))

#define ASI_DFLUSH ASI_LEON3_DFLUSH
#define ASI_IFLUSH ASI_LEON3_IFLUSH

#else
/* other processors */

#endif

/* flush data cache */
static __inline__ void sparc_dcache_flush_all(void) {
  __asm__ __volatile__("sta %%g0, [%%g0] %0\n\t": :
                       "i" (ASI_DFLUSH) : "memory");
}

/* flush instruction cache */
static __inline__ void sparc_icache_flush_all(void) {
  __asm__ __volatile__("sta %%g0, [%%g0] %0\n\t": :
                       "i" (ASI_IFLUSH) : "memory");
}


#endif /* __ASM_SPARC_PROCESSOR_H */
